//Author: George Koutsogiannakis
//Date: 8/31/02
//Date: 9/4/06

import javax.swing.JOptionPane;
import javax.swing.JApplet;
import javax.swing.*;
import java.text.DecimalFormat;
import java.awt.Graphics;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import java.io.*;

public class Mortgagecalculation extends JApplet 
{
	String interest;
	double interestnumber;
	String time;
    String loanamount;
	String result;
	String string;
	double timenumber;
	double decimalinterestnumber;
	double loannumber;
	double payment;
	double z;
	double x;
	double a;
	double y;
	double totalpayments;
	double totalinterest;
	double principlek;
	double balance;
	DecimalFormat twodigits = new DecimalFormat("0.00");
    double loannumberk;
	DefaultTableModel mydefaulttable;
	JTable mytable;
	int k;
	

	public void init()
	{
		
	}

		
	
		
	

	public void start ()
	{
		Mortgagecalculation m=new Mortgagecalculation();
		//Create the Message Dialog Boxes so that the user can enter the information required.
		interest = JOptionPane.showInputDialog (m, "Enter the annual interest rate with up to three decimal places", "	REQUEST FROM USER", 2);
		interestnumber = Double.parseDouble(interest);
		time= JOptionPane.showInputDialog (this, "Enter the time in months");
		timenumber = Double.parseDouble(time);
		loanamount=JOptionPane.showInputDialog (m, "Enter the amount of the loan");
		loannumber=Double.parseDouble(loanamount);
		
		//Use the information captured (from user) to calculate monthly payments
		decimalinterestnumber=interestnumber*0.01;
		System.out.println(decimalinterestnumber);
		z= decimalinterestnumber/12;
		a= (1+z);
		System.out.println(a);
		x= Math.pow( a, timenumber);
		System.out.println(timenumber);
		System.out.println(x);
		y=  1- (1/x);
		payment= (loannumber*z) / y;
		System.out.println(payment);
		
		//Format the payment number to a two digit format to the right of the decimal point.
		//Class decimalFormat belongs to package java.text
		//Display the result on a Message Box
		result="Your montly payment is:"+" "+"$"+" "+twodigits.format(payment);
		JOptionPane.showMessageDialog(this, result , "MONTLY PAYMENT" , JOptionPane.INFORMATION_MESSAGE); 
		
		//When user clicks OK on message box the repaint method calls paint which causes the graphics to be displayed on the Applet container.
		repaint();
		Container c= getContentPane();
		MyPanel panel =new MyPanel();
		panel.setSize (10,40);
		panel.setBackground(Color.gray);

		//create default model of JTable
			mydefaulttable = new DefaultTableModel();
			mydefaulttable.addColumn("PAYMENT NUMBER");
			mydefaulttable.addColumn ("PAYMENT AMOUNT");
			mydefaulttable.addColumn ("PRINCIPLE");
			mydefaulttable.addColumn ("INTEREST");
			mydefaulttable.addColumn("LOAN BALANCE");
		    loannumberk=loannumber;
			 for (k=1; k<=timenumber ; k++ )
				{
					
					principlek=payment-loannumberk*z;
					balance=loannumberk-principlek;
					String[] display = { Integer.toString(k), twodigits.format(payment),  twodigits.format(principlek), twodigits.format(loannumberk*z), twodigits.format(balance)};
					//String[] display= { "hi","hi", "hi", "hi", "hi"};
					loannumberk=loannumberk-principlek;
					mydefaulttable.addRow(display);
					
				}
		    System.out.println("new payment"+payment);
			mytable=new JTable(mydefaulttable);  
		JScrollPane myscrollpane= new JScrollPane (mytable);
       //add the the Jtable to the North section of the BorderLayout
		c.setLayout(new BorderLayout(5,5));
		c.add (myscrollpane, BorderLayout.NORTH);	
			
		
		//add the panel MyPanel (see inner clas below) to teh Center. Displays teh summarries.
		
		c.add (panel, BorderLayout.CENTER);
		
		System.out.println("repainting table");
		
		//Create a text Field to output more information in string
		string="If you would like to exit this program\n"+ "click on the exit button,\n"+
			"if you would like to enter new numbers\n"+ "click on the continue button";
		JTextArea textarea=new JTextArea(string);
		
		//USE "BOX LAYOUT MANAGER" TO ARRANGE COMPONENTS LEFT TO RIGHT WITHIN THE CONTAINER. 
		//THE CONTAINER IS THE TEXT AREA IN THIS CASE.
		
		
		Box box =Box.createHorizontalBox();
		box.add(new JScrollPane (textarea));
		JButton exit=new JButton ("Exit");
		box.add(exit);
		JButton save=new JButton("Save to a Text File");
		box.add(save);
		JButton contin =new JButton ("Continue");
		box.add(contin);
		
		//add box to the south section
		c.add(box, BorderLayout.SOUTH);
		
		exit.addActionListener( new ActionListener() {
				public void actionPerformed (ActionEvent e)
				{
					destroy();
				}
			} //end anonymous inner class
		); // end call to ActionListener
		
		contin.addActionListener( new ActionListener() {
				public void actionPerformed (ActionEvent e)
				{
					start();

				}
			} //end anonymous inner class
		); // end call to ActionListener for "continue"
		
		save.addActionListener(new ActionListener(){
			public void actionPerformed (ActionEvent e)
			{
				JFileChooser filechooser = new JFileChooser ();
				filechooser.setFileSelectionMode ( JFileChooser.FILES_ONLY);
				int result = filechooser.showSaveDialog (null);
				if (result== JFileChooser.CANCEL_OPTION)
					
				{
					return;
				}
				File filename = filechooser.getSelectedFile();
				if (filename==null||filename.getName().equals (" "))
				{
					JOptionPane.showMessageDialog( null, "Invalid File Name", "Invalid FileName", JOptionPane.ERROR_MESSAGE );
				}
				else {
					try
					{
						FileOutputStream file = new FileOutputStream(filename);
						OutputStreamWriter filestream = new OutputStreamWriter(new BufferedOutputStream(file));
						String filestring = "PAYMENT NUMBER"+"   " + "PAYMENT" + "   " + " PRINCIPLE" + "   " + "INTEREST" +"   " + " BALANCE" + "\n";
						filestream.write(filestring);
						double loannumberkf= loannumber;
						System.out.println(timenumber);
						for (int j=1; j<=timenumber ; j++ )
						{
							
							double principlekf=payment-loannumberkf*z;
							double balancef=loannumberkf-principlekf;
							String display ="\n"+ Integer.toString(j)+"                " + twodigits.format(payment)+"        "+ twodigits.format(principlekf)+ "     "+twodigits.format(loannumberkf*z)+ "     "+ twodigits.format(balancef)+"\n";
							filestream.write(display);
							loannumberkf=loannumberkf-principlekf;
							
					
						}
						filestream.flush();
						file.close();
					}
					catch ( IOException ioException )
					{
						JOptionPane.showMessageDialog (null, "File Does not exist", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
					}
					
				}//end of else
				
			}
		} //end anonymous inner class
	);
		System.out.println("I finished repainting");
		//repaint();
	
	}

	public void paint(Graphics g)
	{
		super.paint(g);
		System.out.println("repainting");
		
	
	
	}


	public void destroy ()
	{
		System.exit(0);
	}

	



  class  MyPanel extends JPanel
  {

	 public void paintComponent (Graphics g)
	 {
		super.paintComponent(g);
		totalpayments=timenumber*payment;
		totalinterest = totalpayments-loannumber;
		g.drawString("The total payments made are:"+" " + twodigits.format(totalpayments),10, 60);
		g.drawString("The total interest paid is:"+" " + twodigits.format(totalinterest),10,75);
		
		
		
	 }

	
   }

  
}